local wm = GetWindowManager()

-- Create Friend Icon
local cFriend = wm:CreateTopLevelWindow(nil)
cFriend:SetDimensions(32,32)
cFriend:SetAnchor(CENTER,GuiRoot,CENTER,-50,0)
cFriend.icon = wm:CreateControl(nil, cFriend, CT_TEXTURE)
cFriend.icon:SetTexture("/esoui/art/chatwindow/chat_friendsonline_up.dds")
cFriend.icon:SetAnchorFill(cFriend)     

-- Create Guild Icon
local cGuild = wm:CreateTopLevelWindow(nil)
cGuild:SetDimensions(32,32)
cGuild:SetAnchor(CENTER,GuiRoot,CENTER,50,0)
cGuild.icon = wm:CreateControl(nil, cGuild, CT_TEXTURE)
cGuild.icon:SetTexture("/esoui/art/guild/guildhistory_indexicon_guild_up.dds")
cGuild.icon:SetAnchorFill(cGuild) 

-- If Reticle is hidden then hide icons
local function OnReticleHidden(eventcode,invname)
	cFriend:SetHidden(true)
	cGuild:SetHidden(true)
end

-- If target has changed check it's a valid target then find out if they are friend of guildy
local function OnTargetHasChanged(eventcode,invname)
	cFriend:SetHidden(true)
	cGuild:SetHidden(true)
	-- Get the reticle target
	local target = GetUnitName('reticleover')
	
	-- Ignore blank targets
	local ignore = ( target == "" )
	
	-- We also want to ignore critters
	if CheckIsCritter( target ) then ignore = true end

	if ignore then
		cFriend:SetHidden(true)
		cGuild:SetHidden(true)
	else
		isguild = 0
		for xguildid = 1, GetNumGuilds(), 1 do
			for xmemberid = 1, GetNumGuildMembers(xguildid), 1 do
				charvar = {GetGuildMemberCharacterInfo(xguildid, xmemberid)}
				if charvar[2] == GetRawUnitName('reticleover') then
					cGuild:SetHidden(false)
				end
			end
		end
	end
	if IsUnitFriend( 'reticleover' ) then
		cFriend:SetHidden(false)	
	end
end

-- Init Guild Info
function GuildInfoInit()
	d("Init")
	cFriend:SetHidden(true)
	cGuild:SetHidden(true)
	EVENT_MANAGER:RegisterForEvent("GuildInfo", EVENT_RETICLE_TARGET_CHANGED, OnTargetHasChanged)
	EVENT_MANAGER:RegisterForEvent("GuildInfo", EVENT_RETICLE_HIDDEN_UPDATE, OnReticleHidden)
end

-- Function to check if Critter
function CheckIsCritter( targetName )

	-- Critters are always level 1
	if ( GetUnitLevel('reticleover') ~= 1 ) then return false end

	-- The list of critters
	local critters = { 
		"Butterfly",
		"Lizard",
		"Rat",
		"Snake",
		"Pony Guar",
		"Frog",
		"Squirrel",
		"Rabbit",
		"Deer",
		"Cat",
		"Pig",
		"Sheep",
		"Antelope",
		"Wasp",
		"Monkey",
		"Fleshflies",
		"Centipede",
		"Chicken",
		"Torchbug",
		"Spider",
		"Scorpion",
		"Goat",
		"Scrib",
		"Scuttler",
	}
	
	-- Is the target a critter?
	for i = 1, #critters do
		if ( targetName == critters[i] ) then return true end
	end
	
	-- Otherwise false
	return false
end